stages:
  - tarball
  - installer

linux-64-build:
  stage: tarball
  image: registry.gitlab.com/certik/ci-images:conda_base-1.2.3
  script:
    - export PATH="$HOME/conda_root/bin:$PATH"
    - conda update --all
    - conda install -y python=3.7 conda-build
    - sudo apt-get update
    - sudo apt-get install -yq --no-install-recommends git curl gcc gcc-multilib
    - (cd lfortran && conda-build .)
    - (cd fortran-kernel && conda-build .)
    - conda install -y -c conda-forge dropbox
    - pip install conda-pack
    - mkdir tmp && cd tmp
    - conda create -n lfortran -y -c file://$HOME/conda_root/conda-bld/ python=3.7 fortran-kernel matplotlib
    - conda pack -n lfortran --arcroot lfortran_dist -o lfortran_dist.tar.gz
    - ../ci/upload_tarball.sh
    - ls -lh
  artifacts:
    paths:
      - download_link
    when: always

linux-64-test:
  stage: installer
  image: registry.gitlab.com/certik/ci-images:ubuntu_base-1.2.3
  script:
    - sudo apt-get update
    - sudo apt-get install -yq --no-install-recommends wget
    - wget $(<download_link) -O lfortran_dist.tar.gz
    - tar xzf lfortran_dist.tar.gz
    - source lfortran_dist/bin/activate
    - which python
    - conda-unpack
    - which lfort
    - lfort --help
    - jupyter kernelspec list --json

linux-64-warp:
  stage: installer
  image: registry.gitlab.com/certik/ci-images:conda_base-1.2.3
  script:
    - export PATH="$HOME/conda_root/bin:$PATH"
    - sudo apt-get update
    - sudo apt-get install -yq --no-install-recommends wget curl
    - conda install -y -c conda-forge dropbox
    - wget $(<download_link) -O lfortran_dist.tar.gz
    - cd warp/lfortran
    - tar xzf ../../lfortran_dist.tar.gz
    - cd ..
    - wget https://github.com/dgiagio/warp/releases/download/v0.3.0/linux-x64.warp-packer -O warp-packer
    - chmod +x warp-packer
    - ./warp-packer --arch linux-x64 --input_dir lfortran --exec launch --output lfortran.bin
    - chmod +x lfortran.bin
    - ../ci/upload_warp.sh
